using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using DCON_PC_DOTNET;

namespace ReadDIO
{
	/// <summary>
	/// Form1 的摘要描述。
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox textAddress;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.TextBox textTimeout;
		private System.Windows.Forms.TextBox textChecksum;
		private System.Windows.Forms.TextBox textSlot;
		private System.Windows.Forms.TextBox textBaudrate;
		private System.Windows.Forms.TextBox textComport;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.TextBox textDOTotalCh;
		private System.Windows.Forms.TextBox textDITotalCh;
		private System.Windows.Forms.Button Read_DIO;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Button Open_Com;
		private System.Windows.Forms.Button Close_Com;
		private System.Windows.Forms.TextBox textDIValue;
		private System.Windows.Forms.TextBox textDOValue;
		/// <summary>
		/// 設計工具所需的變數。
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Windows Form 設計工具支援的必要項
			//
			InitializeComponent();

			//
			// TODO: 在 InitializeComponent 呼叫之後加入任何建構函式程式碼
			//
		}

		/// <summary>
		/// 清除任何使用中的資源。
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form 設計工具產生的程式碼
		/// <summary>
		/// 此為設計工具支援所必須的方法 - 請勿使用程式碼編輯器修改
		/// 這個方法的內容。
		/// </summary>
		private void InitializeComponent()
		{
			this.textAddress = new System.Windows.Forms.TextBox();
			this.label11 = new System.Windows.Forms.Label();
			this.textTimeout = new System.Windows.Forms.TextBox();
			this.textChecksum = new System.Windows.Forms.TextBox();
			this.textSlot = new System.Windows.Forms.TextBox();
			this.textBaudrate = new System.Windows.Forms.TextBox();
			this.textComport = new System.Windows.Forms.TextBox();
			this.label5 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.label7 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.textDOTotalCh = new System.Windows.Forms.TextBox();
			this.textDITotalCh = new System.Windows.Forms.TextBox();
			this.textDIValue = new System.Windows.Forms.TextBox();
			this.textDOValue = new System.Windows.Forms.TextBox();
			this.Read_DIO = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.Open_Com = new System.Windows.Forms.Button();
			this.Close_Com = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// textAddress
			// 
			this.textAddress.Location = new System.Drawing.Point(72, 64);
			this.textAddress.Name = "textAddress";
			this.textAddress.Size = new System.Drawing.Size(72, 22);
			this.textAddress.TabIndex = 62;
			this.textAddress.Text = "1";
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(24, 64);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(48, 16);
			this.label11.TabIndex = 61;
			this.label11.Text = "Address";
			// 
			// textTimeout
			// 
			this.textTimeout.Location = new System.Drawing.Point(72, 192);
			this.textTimeout.Name = "textTimeout";
			this.textTimeout.Size = new System.Drawing.Size(72, 22);
			this.textTimeout.TabIndex = 60;
			this.textTimeout.Text = "100";
			// 
			// textChecksum
			// 
			this.textChecksum.Location = new System.Drawing.Point(72, 160);
			this.textChecksum.Name = "textChecksum";
			this.textChecksum.Size = new System.Drawing.Size(72, 22);
			this.textChecksum.TabIndex = 59;
			this.textChecksum.Text = "0";
			// 
			// textSlot
			// 
			this.textSlot.Location = new System.Drawing.Point(72, 128);
			this.textSlot.Name = "textSlot";
			this.textSlot.Size = new System.Drawing.Size(72, 22);
			this.textSlot.TabIndex = 58;
			this.textSlot.Text = "-1";
			// 
			// textBaudrate
			// 
			this.textBaudrate.Location = new System.Drawing.Point(72, 96);
			this.textBaudrate.Name = "textBaudrate";
			this.textBaudrate.Size = new System.Drawing.Size(72, 22);
			this.textBaudrate.TabIndex = 57;
			this.textBaudrate.Text = "9600";
			// 
			// textComport
			// 
			this.textComport.Location = new System.Drawing.Point(72, 32);
			this.textComport.Name = "textComport";
			this.textComport.Size = new System.Drawing.Size(72, 22);
			this.textComport.TabIndex = 56;
			this.textComport.Text = "1";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(16, 200);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(48, 16);
			this.label5.TabIndex = 55;
			this.label5.Text = "Timeout";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 168);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(56, 16);
			this.label4.TabIndex = 54;
			this.label4.Text = "CheckSum";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(24, 136);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(24, 16);
			this.label3.TabIndex = 53;
			this.label3.Text = "Slot";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 96);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(64, 16);
			this.label2.TabIndex = 52;
			this.label2.Text = "Baudrate";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 32);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(48, 16);
			this.label1.TabIndex = 51;
			this.label1.Text = "ComPort";
			// 
			// groupBox2
			// 
			this.groupBox2.Location = new System.Drawing.Point(8, 8);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(144, 224);
			this.groupBox2.TabIndex = 63;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Setting";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(176, 80);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(56, 24);
			this.label7.TabIndex = 67;
			this.label7.Text = "DO Total Channel";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(176, 40);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(48, 24);
			this.label6.TabIndex = 66;
			this.label6.Text = "DI Total Channel";
			// 
			// textDOTotalCh
			// 
			this.textDOTotalCh.Location = new System.Drawing.Point(232, 80);
			this.textDOTotalCh.Name = "textDOTotalCh";
			this.textDOTotalCh.Size = new System.Drawing.Size(48, 22);
			this.textDOTotalCh.TabIndex = 65;
			this.textDOTotalCh.Text = "8";
			// 
			// textDITotalCh
			// 
			this.textDITotalCh.Location = new System.Drawing.Point(232, 40);
			this.textDITotalCh.Name = "textDITotalCh";
			this.textDITotalCh.Size = new System.Drawing.Size(48, 22);
			this.textDITotalCh.TabIndex = 64;
			this.textDITotalCh.Text = "8";
			// 
			// textDIValue
			// 
			this.textDIValue.Location = new System.Drawing.Point(176, 128);
			this.textDIValue.Name = "textDIValue";
			this.textDIValue.Size = new System.Drawing.Size(48, 22);
			this.textDIValue.TabIndex = 68;
			this.textDIValue.Text = "";
			// 
			// textDOValue
			// 
			this.textDOValue.Location = new System.Drawing.Point(176, 160);
			this.textDOValue.Name = "textDOValue";
			this.textDOValue.Size = new System.Drawing.Size(48, 22);
			this.textDOValue.TabIndex = 69;
			this.textDOValue.Text = "";
			// 
			// Read_DIO
			// 
			this.Read_DIO.Location = new System.Drawing.Point(232, 120);
			this.Read_DIO.Name = "Read_DIO";
			this.Read_DIO.Size = new System.Drawing.Size(48, 64);
			this.Read_DIO.TabIndex = 70;
			this.Read_DIO.Text = "Read DIO";
			this.Read_DIO.Click += new System.EventHandler(this.Read_DIO_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.Location = new System.Drawing.Point(160, 8);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(128, 224);
			this.groupBox1.TabIndex = 71;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "DIO";
			// 
			// Open_Com
			// 
			this.Open_Com.Location = new System.Drawing.Point(56, 240);
			this.Open_Com.Name = "Open_Com";
			this.Open_Com.Size = new System.Drawing.Size(72, 32);
			this.Open_Com.TabIndex = 72;
			this.Open_Com.Text = "Open Com";
			this.Open_Com.Click += new System.EventHandler(this.Open_Com_Click);
			// 
			// Close_Com
			// 
			this.Close_Com.Location = new System.Drawing.Point(176, 240);
			this.Close_Com.Name = "Close_Com";
			this.Close_Com.Size = new System.Drawing.Size(72, 32);
			this.Close_Com.TabIndex = 73;
			this.Close_Com.Text = "Close Com";
			this.Close_Com.Click += new System.EventHandler(this.Close_Com_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 15);
			this.ClientSize = new System.Drawing.Size(296, 277);
			this.Controls.Add(this.Close_Com);
			this.Controls.Add(this.Open_Com);
			this.Controls.Add(this.Read_DIO);
			this.Controls.Add(this.textDOValue);
			this.Controls.Add(this.textDIValue);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.textDOTotalCh);
			this.Controls.Add(this.textDITotalCh);
			this.Controls.Add(this.textAddress);
			this.Controls.Add(this.label11);
			this.Controls.Add(this.textTimeout);
			this.Controls.Add(this.textChecksum);
			this.Controls.Add(this.textSlot);
			this.Controls.Add(this.textBaudrate);
			this.Controls.Add(this.textComport);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.groupBox1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// 應用程式的主進入點。
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		short iSlot,iTimeout,iAddress,bChecksum;
		byte iComport;
		uint iBaudrate;
		
		private void Read_DIO_Click(object sender, System.EventArgs e)
		{
			uint DIValue;
			uint DOValue;
			short iRet;

			iRet=DCON.IO_Function.Read_DIO(iComport,iAddress,iSlot,Convert.ToInt16(textDITotalCh.Text),
					Convert.ToInt16(textDOTotalCh.Text),bChecksum,iTimeout,
					              out DIValue,out DOValue);
			
			if(Convert.ToBoolean( iRet))
				MessageBox.Show("ErrorCode " + Convert.ToString(iRet));
			else{
				textDIValue.Text=Convert.ToString(DIValue,16);
				textDOValue.Text=Convert.ToString(DOValue,16);}
		}

		private void Close_Com_Click(object sender, System.EventArgs e)
		{
			DCON.UART.Close_Com(iComport);
		}

		private void Open_Com_Click(object sender, System.EventArgs e)
		{
			iComport=Convert.ToByte(textComport.Text);
			iAddress = Convert.ToInt16(textAddress.Text);
			iBaudrate=Convert.ToUInt32(textBaudrate.Text);
			iSlot=Convert.ToInt16(textSlot.Text);
			bChecksum=Convert.ToInt16(textChecksum.Text);
			iTimeout=Convert.ToInt16(textTimeout.Text);
			

			DCON.UART.Open_Com(iComport,iBaudrate,8,0,1);
		}
	}
}
